From 3d9eec0c88ee22f4f4ea65d675f2aaeae89d48b1 Mon Sep 17 00:00:00 2001
From: Dmitri Pal <dpal@redhat.com>
Date: Thu, 15 Apr 2010 17:27:04 -0400
Subject: [PATCH] [INI] Code restructuring

Time came to split ini_config.c
into many much smaller pieces.

1) ini_parse.c - will have parsing functions
2) ini_get_value.c - will have single value
interpretation functions
3) ini_get_array.c - will have array interpretation
functions.
4) ini_print.c - error printing
5) ini_defines.h - common constants
6) ini_parse.h header for parsing functions
7) ini_list.c - will have list processing functions
---
 common/ini/Makefile.am     |   11 +-
 common/ini/ini_config.c    | 1476 +-------------------------------------------
 common/ini/ini_config.h    |    3 +
 common/ini/ini_defines.h   |   74 +++
 common/ini/ini_get_array.c |  354 +++++++++++
 common/ini/ini_get_value.c |  523 ++++++++++++++++
 common/ini/ini_list.c      |  123 ++++
 common/ini/ini_parse.c     |  190 ++++++
 common/ini/ini_parse.h     |   36 ++
 common/ini/ini_print.c     |  387 ++++++++++++
 10 files changed, 1705 insertions(+), 1472 deletions(-)
 create mode 100644 common/ini/ini_defines.h
 create mode 100644 common/ini/ini_get_array.c
 create mode 100644 common/ini/ini_get_value.c
 create mode 100644 common/ini/ini_list.c
 create mode 100644 common/ini/ini_parse.c
 create mode 100644 common/ini/ini_parse.h
 create mode 100644 common/ini/ini_print.c

diff --git a/common/ini/Makefile.am b/common/ini/Makefile.am
index a72ce3a..1dc55d9 100644
--- a/common/ini/Makefile.am
+++ b/common/ini/Makefile.am
@@ -34,8 +34,17 @@ dist_include_HEADERS = \
 lib_LTLIBRARIES = libini_config.la
 libini_config_la_SOURCES = \
     ini_config.c \
+    ini_config.h \
+    ini_get_value.c \
+    ini_get_array.c \
+    ini_list.c \
+    ini_print.c \
+    ini_parse.c \
+    ini_parse.h \
     ini_metadata.c \
-    ini_metadata.h
+    ini_metadata.h \
+    ini_defines.h
+
 
 libini_config_la_LIBADD = \
     -L$(topbuilddir)/collection \
diff --git a/common/ini/ini_config.c b/common/ini/ini_config.c
index 1c8e4ae..b9cd6eb 100644
--- a/common/ini/ini_config.c
+++ b/common/ini/ini_config.c
@@ -21,220 +21,19 @@
 */
 
 #define _GNU_SOURCE
-#include <stdio.h>
 #include <errno.h>
 #include <string.h>
-#include <ctype.h>
 #include <stdlib.h>
-#include <locale.h>
-#include <fcntl.h>
-#include <unistd.h>
-#include <limits.h>
 #include "config.h"
-/* For error text */
-#include <libintl.h>
-#define _(String) gettext (String)
-/* INI file is used as a collection */
+#include "trace.h"
 #include "collection.h"
 #include "collection_tools.h"
-#include "trace.h"
-#include "ini_config.h"
-#include "ini_metadata.h"
 #include "path_utils.h"
+#include "ini_defines.h"
+#include "ini_parse.h"
+#include "ini_metadata.h"
+#include "ini_config.h"
 
-#define NAME_OVERHEAD   10
-
-#define SLASH           "/"
-
-#define EXCLUDE_EMPTY   0
-#define INCLUDE_EMPTY   1
-
-/* Name of the special collection used to store parsing errors */
-#define FILE_ERROR_SET  "ini_file_error_set"
-
-/* Text error strings used when errors are printed out */
-#define WARNING_TXT         _("Warning")
-#define ERROR_TXT           _("Error")
-/* For parse errors */
-#define WRONG_COLLECTION    _("Passed in list is not a list of parse errors.\n")
-#define FAILED_TO_PROCCESS  _("Internal Error. Failed to process error list.\n")
-#define ERROR_HEADER        _("Parsing errors and warnings in file: %s\n")
-/* For grammar errors */
-#define WRONG_GRAMMAR       _("Passed in list is not a list of grammar errors.\n")
-#define FAILED_TO_PROC_G    _("Internal Error. Failed to process list of grammar errors.\n")
-#define ERROR_HEADER_G      _("Logical errors and warnings in file: %s\n")
-/* For validation errors */
-#define WRONG_VALIDATION    _("Passed in list is not a list of validation errors.\n")
-#define FAILED_TO_PROC_V    _("Internal Error. Failed to process list of validation errors.\n")
-#define ERROR_HEADER_V      _("Validation errors and warnings in file: %s\n")
-
-#define LINE_FORMAT         _("%s (%d) on line %d: %s\n")
-
-
-/* Codes that parsing function can return */
-#define RET_PAIR        0
-#define RET_COMMENT     1
-#define RET_SECTION     2
-#define RET_INVALID     3
-#define RET_EMPTY       4
-#define RET_EOF         5
-#define RET_ERROR       6
-
-#define INI_ERROR       "errors"
-#define INI_ERROR_NAME  "errname"
-
-/* Internal sizes. MAX_KEY is defined in config.h */
-#define MAX_VALUE       PATH_MAX
-#define BUFFER_SIZE     MAX_KEY + MAX_VALUE + 3
-
-/* Beffer length used for int to string conversions */
-#define CONVERSION_BUFFER 80
-
-/*============================================================*/
-/* The following classes moved here from the public header
- * They are reserved for future use.
- *
- * NOTE: before exposing these constants again in the common header
- * check that the class IDs did not get reused over time by
- * other classes.
- */
-/** @brief Collection of grammar errors.
- *
- * Reserved for future use.
- */
-#define COL_CLASS_INI_GERROR      COL_CLASS_INI_BASE + 5
-/** @brief Collection of validation errors.
- *
- * Reserved for future use.
- */
-#define COL_CLASS_INI_VERROR      COL_CLASS_INI_BASE + 6
-
-#ifdef HAVE_VALIDATION
-
-/** @brief Collection of lines from the INI file.
- *
- * Reserved for future use
- */
-#define COL_CLASS_INI_LINES       COL_CLASS_INI_BASE + 7
-
-#endif /* HAVE_VALIDATION */
-/*============================================================*/
-
-
-/* Different error string functions can be passed as callbacks */
-typedef const char * (*error_fn)(int error);
-
-/* Function to return parsing error */
-const char *parsing_error_str(int parsing_error)
-{
-    const char *placeholder= _("Unknown pasing error.");
-    const char *str_error[] = { _("Data is too long."),
-                                _("No closing bracket."),
-                                _("Section name is missing."),
-                                _("Section name is too long."),
-                                _("Equal sign is missing."),
-                                _("Property name is missing."),
-                                _("Property name is too long.")
-    };
-
-    /* Check the range */
-    if ((parsing_error < 1) || (parsing_error > ERR_MAXPARSE))
-            return placeholder;
-    else
-            return str_error[parsing_error-1];
-}
-
-/* Function to return grammar error.
- * This function is currently not used.
- * It is planned to be used by the INI
- * file grammar parser.
- *
- * The following doxygen description is moved here.
- * When the function gets exposed move it into
- * the header file.
- */
-/** @brief Function to return a grammar error in template.
- *
- * EXPERIMENTAL. Reserved for future use.
- *
- * This error is returned when the template
- * is translated into the grammar object.
- *
- * @param[in] parsing_error    Error code for the grammar error.
- *
- * @return Error string.
- */
-
-const char *grammar_error_str(int grammar_error)
-{
-    const char *placeholder= _("Unknown grammar error.");
-    /* THIS IS A TEMPORARY PLACEHOLDER !!!! */
-    const char *str_error[] = { _(""),
-                                _(""),
-                                _(""),
-                                _(""),
-                                _(""),
-                                _(""),
-                                _("")
-    };
-
-    /* Check the range */
-    if ((grammar_error < 1) || (grammar_error > ERR_MAXGRAMMAR))
-            return placeholder;
-    else
-            return str_error[grammar_error-1];
-}
-
-/* Function to return validation error.
- * This function is currently not used.
- * It is planned to be used by the INI
- * file grammar validator.
- *
- * The following doxygen description is moved here.
- * When the function gets exposed move it into
- * the header file.
- */
-/** @brief Function to return a validation error.
- *
- * EXPERIMENTAL. Reserved for future use.
- *
- * This is the error that it is returned when
- * the INI file is validated against the
- * grammar object.
- *
- * @param[in] parsing_error    Error code for the validation error.
- *
- * @return Error string.
- */
-const char *validation_error_str(int validation_error)
-{
-    const char *placeholder= _("Unknown validation error.");
-    /* THIS IS A TEMPORARY PLACEHOLDER !!!! */
-    const char *str_error[] = { _(""),
-                                _(""),
-                                _(""),
-                                _(""),
-                                _(""),
-                                _(""),
-                                _("")
-    };
-
-    /* Check the range */
-    if ((validation_error < 1) || (validation_error > ERR_MAXVALID))
-            return placeholder;
-    else
-            return str_error[validation_error-1];
-}
-
-
-/* Internal function to read line from INI file */
-int read_line(FILE *file,
-              char *buf,
-              int read_size,
-              char **key,
-              char **value,
-              int *length,
-              int *ext_error);
 
 /***************************************************************************/
 /* Function to read single ini file and pupulate
